#ifndef _SOBOL_H
#define _SOBOL_H

/* 
    Copyright Emanouil Atanassov, 2003
    This file is part of the Fast Generator for the Sobol Sequences.

    The Fast Generator for the Sobol Sequences
    is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

     The Fast Generator for the Sobol Sequences 
    is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */




#ifdef __cplusplus
extern "C" {
#endif
/*
uncomment if single precision required (or better change the makefile)
#define SOBOL_SINGLE   

*/

/* 
uncomment if optimized version for the particular processor is needed
(P3 works on P4 too, 
MMX works  on P3, P4 and ATHLON, 
ATHLON in double precision is impossible, use MMX
ALTIVEC works only with the motorola vector compiler (gcc -fvec):
#define SOBOL_P3
#define SOBOL_P4
#define SOBOL_MMX
#define SOBOL_ALTIVEC

*/



#define SOBOL_MAXDIM 384
#ifdef  SOBOL_SINGLE
#define SOBOL_MAXPOW 23
#define SOBOL_DIGITS 32
#define SOBOL_SCLIM  7
#define SOBOL_PLUS1 0x3f800000
#define sobol_real float
typedef  int sobol_int;
#else
#define SOBOL_DIGITS 64
#define SOBOL_MAXPOW 52
#define SOBOL_SCLIM  4
#define SOBOL_PLUS1 0x3ff0000000000000LL
typedef long long int sobol_int;
#define sobol_real double
#endif

extern void sobolreaddata();
extern void sobolpreprocess(int,int,sobol_int,sobol_int *);       	
extern void sobolnextpoint(sobol_real*);
double sobol_test_getpoint(sobol_int ,int ,sobol_int);
extern void *sobolalignmem(int);
extern void sobolnexttraj();
extern int  soboldim;
extern int  sobolcurdim;
extern sobol_real sobolranpoints[SOBOL_MAXDIM];
extern int sobolprepare(double fromtraj,  int maxlentraj);
extern double (*sobolranfunc)();
extern sobol_real* sobolptr;
extern sobol_real *sobolrbound;
#define sobolnextcoord() (*sobolptr++)
#define sobolnextcoordr() ((sobolptr<sobolrbound)?*sobolptr++:sobolranfunc())
extern void sobolrewind(int,  int, sobol_int , sobol_int*);

#ifdef __cplusplus
}
#endif
#endif
