/* 
    Copyright Emanouil Atanassov, 2003
    This file is part of the Fast Generator for the Sobol Sequences.

    The Fast Generator for the Sobol Sequences
    is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

     The Fast Generator for the Sobol Sequences 
    is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    */


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <assert.h>
#include "sobol.h"
static sobol_int y[SOBOL_MAXDIM] __attribute__ ((aligned(16)));
static sobol_int z[SOBOL_MAXDIM] __attribute__ ((aligned(16)));
static sobol_int twist[SOBOL_MAXPOW][SOBOL_MAXDIM]
    __attribute__ ((aligned(16)));
static sobol_int twistpack[SOBOL_MAXPOW][SOBOL_MAXDIM]
    __attribute__ ((aligned(16)));
static sobol_int avect[SOBOL_MAXPOW][SOBOL_MAXDIM]
    __attribute__ ((aligned(16)));
static int twnum;
int soboldim;
static sobol_int N;		/* current point */
/* izlishno za statiata a*/
typedef unsigned long long llongint;
#define LLONG llongint
#include "sobolvec.h"
static void prd(sobol_int i)
{
    sobol_int j, l;
    for (j = 0, l = 1; j < sizeof(sobol_int) * 8; j++) {
	if (i & l)
	    printf("1");
	else
	    printf("0");
	l = l << 1;
    }
    printf("\n");
}
static int dataread = 0;
void sobolreaddata()
{
    int i, j;
    for (i = 0; i < SOBOL_MAXDIM; i++) {
	for (j = 0; (j < SOBOL_MAXPOW) & (j < SOBOL_MAXROWSINTABLE); j++) {
	    avect[j][i] = sobolgen_dat_array[SOBOL_MAXROWSINTABLE * i + j];
	}
    }
    dataread++;
}

#ifdef SOBOL_ATHLON
#ifdef SOBOL_SINGLE
static packdatsimple(sobol_int * source, char *dest, int n)
{
    int i, j, k;
    for (i = 0; i < n >> 3; i++) {
	for (k = 0; k < 8; k++) {
	    dest[k + i * 8] = ((char *) (source + i * 8 + k))[2];
	}
    }
    source = source + (n & ~7);
    dest = dest + (n & ~7);

    for (i = 0; i < (n & 7); i++) {
	((int *) dest)[i] = source[i];
    }
}
static packdatcomplex(sobol_int * source, char *dest, int n)
{
    int i, j, k;
    for (i = 0; i < n / 8; i++) {
	for (k = 0; k < 8; k++) {
	    dest[k] = ((char *) (source + k))[2];
	    dest[8 + 2 * k] = ((char *) (source + k))[0];
	    dest[8 + 2 * k + 1] = ((char *) (source + k))[1];
	}
	source += 8;
	dest += 8 * 3;
    }
    for (i = 0; i < (n & 7); i++) {
	((int *) dest)[i] = source[i];
    }

}
#endif
#endif
#ifdef SOBOL_P4
#ifdef SOBOL_SINGLE
static packdatsimple(sobol_int * source, char *dest, int n)
{
    int i, j, k;
    for (i = 0; i < n / 16; i++) {
	for (k = 0; k < 16; k++) {
	    dest[k + i * 16] = ((char *) (source + i * 16 + k))[2];
	}
    }
    source = source + (n & ~15);
    dest = dest + (n & ~15);
    for (i = 0; i < (n & 15); i++) {
	((int *) dest)[i] = source[i];
    }
}
static packdatcomplex(sobol_int * source, char *dest, int n)
{
    int i, j, k;
    for (i = 0; i < n / 16; i++) {
	for (k = 0; k < 16; k++) {
	    dest[k] = ((char *) (source + k))[2];
	    dest[16 + 2 * k] = ((char *) (source + k))[0];
	    dest[16 + 2 * k + 1] = ((char *) (source + k))[1];
	}
	source += 16;
	dest += 16 * 3;
    }
    for (i = 0; i < (n & 15); i++) {
	((int *) dest)[i] = source[i];
    }
}

#else
static int packdatsimple(long long int *source, char *dest, int n)
{
    int i, j, k;
    for (i = 0; i < n / 16; i++) {
	for (k = 0; k < 16; k++) {
	    dest[k + i * 16] = ((char *) (source + i * 16 + k))[6];
	}
    }
    source = source + (n & ~15);
    dest = dest + (n & ~15);
    for (i = 0; i < (n & 15); i++) {
	((long long int *) dest)[i] = source[i];
    }

}
static int packdatcomplex(long long int *source, char *dest, int n)
{
    int i, j, k;
    for (i = 0; i < n / 16; i++) {
	for (k = 0; k < 8; k++) {
	    dest[0 + k] = ((char *) (source + k))[6];
	    dest[16 + k * 2] = ((char *) (source + k))[4];
	    dest[16 + k * 2 + 1] = ((char *) (source + k))[5];
	    dest[32 + k * 4 + 0] = ((char *) (source + k))[0];
	    dest[32 + k * 4 + 1] = ((char *) (source + k))[1];
	    dest[32 + k * 4 + 2] = ((char *) (source + k))[2];
	    dest[32 + k * 4 + 3] = ((char *) (source + k))[3];
	}
	source += 8;
	for (k = 0; k < 8; k++) {
	    dest[8 + k] = ((char *) (source + k))[6];
	    dest[64 + k * 2] = ((char *) (source + k))[4];
	    dest[64 + k * 2 + 1] = ((char *) (source + k))[5];
	    dest[80 + k * 4 + 0] = ((char *) (source + k))[0];
	    dest[80 + k * 4 + 1] = ((char *) (source + k))[1];
	    dest[80 + k * 4 + 2] = ((char *) (source + k))[2];
	    dest[80 + k * 4 + 3] = ((char *) (source + k))[3];
	}
	source += 8;
	dest += 112;
    }
    for (i = 0; i < (n & 15); i++) {
	((long long int *) dest)[i] = source[i];
    }
}

#endif

#endif
static int firstpass = 0;

void sobolrewind(int dim,  int scale, sobol_int toN, sobol_int*scrambles){
{
    int i, j;
    sobol_int l;
    sobol_int oldN=N;
    N = toN >> scale;
    twnum = scale;
    firstpass=0;//!
#if (defined(SOBOL_ATHLON )&&(defined(SOBOL_SINGLE))) ||  defined(SOBOL_P4)
/* Be careful - must make sure the assignment of 1.0 to z is made before the integer (^) ops 
Sometimes compiler optimization (reordering of statements etc.) can create problems!
*/
    for (i = 0; i < soboldim; i++) {
	*((sobol_real *) & z[i]) = 1.0;
    }
    for (i = 0; i < soboldim; i++) {
	z[i] ^= scrambles[i];
	for (j = 0, l = 1; (j < SOBOL_MAXPOW)&&(l<=toN) ; j++, l = l + l) {
	    if (from & l) {
		z[i] ^= avect[j][i] << (SOBOL_MAXPOW - 1 - j);
	    }
	}
    }
    packdatcomplex(z, (char *) y, soboldim);
    return;
#endif
    for (i = 0; i < soboldim; i++) {
	y[i] = SOBOL_PLUS1 ^ scrambles[i];
	for (j = 0, l = 1; (j < SOBOL_MAXPOW)&&(l<=toN); j++, l = l + l) {
	    if (toN & l) {
		y[i] ^= avect[j][i] << (SOBOL_MAXPOW - 1 - j);
	    }
	}
    }
    /*
       #ifdef SOBOL_MMX
       for(j=0;j+twnum<SOBOL_SCLIM;j++){
       for(i=0;i<soboldim;i++){
       #ifdef SOBOL_SINGLE 
       ((char*)twist[j])[i]= ((char*)&twist[j][i])[2];
       #else
       ((char*)twist[j])[i]= ((char*)&twist[j][i])[6];  
       #endif
       }
       }
       #endif
 *//* mai e izlichno */
}

}
void sobolpreprocess(int Dim, int scale, sobol_int from,
		     sobol_int * scrambles)
{
    int i, j;
    sobol_int l;
    soboldim = Dim;
    if (dataread != 1) {
	abort();
    }
    N = from >> scale;
    twnum = scale;
#if (defined(SOBOL_ATHLON )&&(defined(SOBOL_SINGLE))) ||  defined(SOBOL_P4)
/* Be careful - must make sure the assignment of 1.0 to z is made before the integer (^) ops 
Sometimes compiler optimization (reordering of statements etc.) can create problems!
*/
    for (i = 0; i < soboldim; i++) {
	*((sobol_real *) & z[i]) = 1.0;
    }
    for (i = 0; i < soboldim; i++) {
	z[i] ^= scrambles[i];
	for (j = 0, l = 1; (j < SOBOL_MAXPOW); j++, l = l + l) {//ne znam zashto j<30 imashe tyka? 
		//apparently SOBOL_MAXROWSINTABLE is important - 
		if (j<SOBOL_MAXROWSINTABLE){
	
	    if (from & l) {
		z[i] ^= avect[j][i] << (SOBOL_MAXPOW - 1 - j);
	    }
		}
	}
    }
    packdatcomplex(z, (char *) y, soboldim);
    for (i = 0; i < soboldim; i++) {
	twist[0][i] = avect[scale][i] << (SOBOL_MAXPOW - 1 - scale);
	for (j = 1; j < SOBOL_MAXPOW - scale; j++) {
	    twist[j][i] =
		(avect[j + scale][i] << (SOBOL_MAXPOW - 1 - j - scale)) ^
		twist[j - 1][i];
	}
    }
    for (j = 0; j < SOBOL_MAXPOW - scale; j++) {
	if (j + scale < SOBOL_SCLIM) {
	    packdatsimple(twist[j], (char *) (twistpack[j]), soboldim);
	} else {
	    packdatcomplex(twist[j], (char *) (twistpack[j]), soboldim);
	}
    }
    return;
#endif
    for (i = 0; i < soboldim; i++) {
	y[i] = SOBOL_PLUS1 ^ scrambles[i];
	for (j = 0, l = 1; j < SOBOL_MAXPOW; j++, l = l + l) {
	if (j<SOBOL_MAXROWSINTABLE){
	    if (from & l) {
		y[i] ^= avect[j][i] << (SOBOL_MAXPOW - 1 - j);
	    }
	   }
	}
    }
    for (i = 0; i < soboldim; i++) {
	twist[0][i] = avect[scale][i] << (SOBOL_MAXPOW - 1 - scale);
	for (j = 1; j < SOBOL_MAXPOW - scale; j++) {
	    twist[j][i] =
		(avect[j + scale][i] << (SOBOL_MAXPOW - 1 - j - scale)) ^
		twist[j - 1][i];
	}
    }
       #ifdef SOBOL_MMX
       for(j=0;j+twnum<SOBOL_SCLIM;j++){
       for(i=0;i<soboldim;i++){
       #ifdef SOBOL_SINGLE 
       ((char*)twist[j])[i]= ((char*)&twist[j][i])[2];
       #else
       ((char*)twist[j])[i]= ((char*)&twist[j][i])[6];  
       #endif
       }
       }
       #endif
    /* mai ne e izlishno */
}

void sobolnextpoint(sobol_real * result)
{

    int i, k;
    sobol_int l;
    if (firstpass == 0) {
	for (i = 0; i < soboldim; i++) {
#if (defined(SOBOL_ATHLON)&&defined(SOBOL_SINGLE))||(defined(SOBOL_P4))
	    /* If shuffling was performed, we are here */
	    result[i] = *(sobol_real *) (z + i) + (-1);
#else
	    result[i] = *(sobol_real *) (y + i) + (-1);
#endif
	}
	firstpass++;
	return;
    }
/* We are here only if   passing not for the first time through sobolnextpoint */
    N++;
    for (l = 1, k = 0; (N & l) == 0; l = l + l, k++);	/* determine the first nonzero digit of n */
/* Depending on processor type, generate optimized or non-optimized code */
#ifdef  SOBOL_ALTIVEC
    /* PowerPC AltiVec instructions */
#ifdef SOBOL_SINGLE
    if (soboldim < 20) {
	/* general code */
	for (i = 0; i < soboldim; i++)
	    y[i] ^= twist[k][i];
	for (i = 0; i < soboldim; i++)
	    result[i] = *(sobol_real *) (y + i) + (-1);
	return;
    } else {
	/* dimension - at least 20, AltiVec specific code */
	sobol_int *lptr;
	sobol_real *lptrbuf;
/* Some macros for the vector instructions */

#define defb(i) vB##i asm("v" #i )
#define defa(i,j) vA##i asm("v" #j )
	register vector long defb(0), defb(1), defb(2), defb(3), defb(4),
	    defb(5), defb(6), defb(7);
	register vector long defa(0, 8), defa(1, 9), defa(2, 10), defa(3,
								       11),
	    defa(4, 12), defa(5, 13), defa(6, 14), defa(7, 15);
	register vector float vM asm("v16");
	register vector long *pA0, *pA1, *pA2, *pA3;
	register vector float *pR0, *pR1, *pR2, *pR3;
	register vector long *pB0, *pB1, *pB2, *pB3;
	register vector long *pA4, *pA5, *pA6, *pA7;
	register vector float *pR4, *pR5, *pR6, *pR7;
	register vector long *pB4, *pB5, *pB6, *pB7;
	register int off0 asm("r5");
	register int off1 asm("r6");
	vector float m1 = (vector float) (-1, -1, -1, -1);
#define vecldA(i,j)  __asm__ __volatile__("lvxl %0,%1,%2": :"v"(vA##i),"r"(off##j),"r"(pA##i))
#define vecldB(i,j)  __asm__ __volatile__("lvxl %0,%1,%2": :"v"(vB##i),"r"(off##j),"r"(pB##i))
#define xorbc(i)    __asm__ __volatile__("vxor %0,%0,%1": :"v"(vA##i),"v"(vB0))
#define xornow(i)    __asm__ __volatile__("vxor %0,%0,%1": :"v"(vA##i),"v"(vB##i))
#define subnow(i)    __asm__ __volatile__("vaddfp %0,%0,%1": :"v"(vA##i),"v"(vM))
#define vecstAA(i,j) __asm__ __volatile__("stvx %0,%1,%2": : "v"(vA##i),"r"(off##j),"r"(pA##i))
#define vecstAR(i,j) __asm__ __volatile__("stvx %0,%1,%2": : "v"(vA##i),"r"(pR##i),"r"(off##j))

	lptr = twist[k];
	lptrbuf = (sobol_real *) y;
	off0 = -(((soboldim - 20) & ~31) << 2);	/* off0 should have the correct alignment */
	pA0 = (vector long *) ((char *) lptrbuf - off0);
	pA1 = pA0 + 1;
	pA2 = pA0 + 2;
	pA3 = pA0 + 3;
	pA4 = pA0 + 4;
	pA5 = pA0 + 5;
	pA6 = pA0 + 6;
	pA7 = pA0 + 7;
	pB0 = (vector long *) ((char *) lptr - off0);
	pB1 = pB0 + 1;
	pB2 = pB0 + 2;
	pB3 = pB0 + 3;
	pB4 = pB0 + 4;
	pB5 = pB0 + 5;
	pB6 = pB0 + 6;
	pB7 = pB0 + 7;
	pR0 = (vector float *) ((char *) result - off0);
	pR1 = pR0 + 1;
	pR2 = pR0 + 2;
	pR3 = pR0 + 3;
	pR4 = pR0 + 4;
	pR5 = pR0 + 5;
	pR6 = pR0 + 6;
	pR7 = pR0 + 7;
	vM = m1;
	off1 = off0 + 128;
	if ((k + twnum) == 0) {
	    vecldB(0, 0);
	    if (off0 <= -128) {
		vecldA(0, 0);
		vecldA(1, 0);
		vecldA(2, 0);
		xorbc(0);
		vecldA(3, 0);
		xorbc(1);
		vecstAA(0, 0);
		vecldA(4, 0);
		xorbc(2);
		vecstAA(1, 0);
		subnow(0);
		do {
		    vecldA(5, 0);
		    xorbc(3);
		    vecstAA(2, 0);
		    subnow(1);
		    vecstAR(0, 0);
		    vecldA(6, 0);
		    xorbc(4);
		    vecstAA(3, 0);
		    subnow(2);
		    vecstAR(1, 0);
		    vecldA(7, 0);
		    xorbc(5);
		    vecstAA(4, 0);
		    subnow(3);
		    vecstAR(2, 0);
		    vecldA(0, 1);
		    xorbc(6);
		    vecstAA(5, 0);
		    subnow(4);
		    vecstAR(3, 0);
		    vecldA(1, 1);
		    xorbc(7);
		    vecstAA(6, 0);
		    subnow(5);
		    vecstAR(4, 0);
		    vecldA(2, 1);
		    xorbc(0);
		    vecstAA(7, 0);
		    subnow(6);
		    vecstAR(5, 0);
		    vecldA(3, 1);
		    xorbc(1);
		    vecstAA(0, 1);
		    subnow(7);
		    vecstAR(6, 0);
		    vecldA(4, 1);
		    xorbc(2);
		    vecstAA(1, 1);
		    subnow(0);
		    vecstAR(7, 0);
		    off0 = off1;
		    off1 += 128;
		} while (off0);
		xorbc(3);
		vecstAA(2, 0);
		subnow(1);
		vecstAR(0, 0);
		xorbc(4);
		vecstAA(3, 0);
		subnow(2);
		vecstAR(1, 0);
		vecstAA(4, 0);
		subnow(3);
		vecstAR(2, 0);
		subnow(4);
		vecstAR(3, 0);
		vecstAR(4, 0);
/* Finish the unrolled loop */
		i = ((int) (lptrbuf + (soboldim & ~3)) - ((int) pA0));
		for (k = 80; k < i; k += 16) {
		    vA0 = vec_ld(k, pA0);
		    vA0 = vec_xor(vA0, vB0);
		    vec_st(vA0, k, pA0);
		    __asm__
			__volatile__("vaddfp %0,%0,%1":"=v"(vA0):"v"(vM));
		    vec_st(vA0, k, (vector long *) pR0);
		}
	    } else {
		/* when  soboldim<20+32 */
		pA0 = (vector long *) lptrbuf;
		pR0 = (vector float *) result;
		for (k = 0; k < (soboldim & ~3) << 2; k += 16) {
		    vA0 = vec_ld(k, pA0);
		    vA0 = vec_xor(vA0, vB0);
		    vec_st(vA0, k, pA0);
		    __asm__
			__volatile__("vaddfp %0,%0,%1":"=v"(vA0):"v"(vM));
		    vec_st(vA0, k, (vector long *) pR0);
		}
	    }
	} else {
	    if (off0 <= -128) {
		vecldA(0, 0);
		vecldA(1, 0);
		vecldB(0, 0);
		vecldA(2, 0);
		vecldB(1, 0);
		xornow(0);
		vecldA(3, 0);
		vecldB(2, 0);
		xornow(1);
		vecstAA(0, 0);
		vecldA(4, 0);
		vecldB(3, 0);
		xornow(2);
		vecstAA(1, 0);
		subnow(0);
		do {
		    vecldA(5, 0);
		    vecldB(4, 0);
		    xornow(3);
		    vecstAA(2, 0);
		    subnow(1);
		    vecstAR(0, 0);
		    vecldA(6, 0);
		    vecldB(5, 0);
		    xornow(4);
		    vecstAA(3, 0);
		    subnow(2);
		    vecstAR(1, 0);
		    vecldA(7, 0);
		    vecldB(6, 0);
		    xornow(5);
		    vecstAA(4, 0);
		    subnow(3);
		    vecstAR(2, 0);
		    vecldA(0, 1);
		    vecldB(7, 0);
		    xornow(6);
		    vecstAA(5, 0);
		    subnow(4);
		    vecstAR(3, 0);
		    vecldA(1, 1);
		    vecldB(0, 1);
		    xornow(7);
		    vecstAA(6, 0);
		    subnow(5);
		    vecstAR(4, 0);
		    vecldA(2, 1);
		    vecldB(1, 1);
		    xornow(0);
		    vecstAA(7, 0);
		    subnow(6);
		    vecstAR(5, 0);
		    vecldA(3, 1);
		    vecldB(2, 1);
		    xornow(1);
		    vecstAA(0, 1);
		    subnow(7);
		    vecstAR(6, 0);
		    vecldA(4, 1);
		    vecldB(3, 1);
		    xornow(2);
		    vecstAA(1, 1);
		    subnow(0);
		    vecstAR(7, 0);
		    off0 = off1;
		    off1 += 128;
		} while (off0);
		vecldB(4, 0);
		xornow(3);
		vecstAA(2, 0);
		subnow(1);
		vecstAR(0, 0);
		xornow(4);
		vecstAA(3, 0);
		subnow(2);
		vecstAR(1, 0);
		vecstAA(4, 0);
		subnow(3);
		vecstAR(2, 0);
		subnow(4);
		vecstAR(3, 0);
		vecstAR(4, 0);
/* Finish the unroled loop */
		i = ((int) (lptrbuf + (soboldim & ~3)) - ((int) pA0));
		for (k = 80; k < i; k += 16) {
		    vA0 = vec_ld(k, pA0);
		    vB0 = vec_ld(k, pB0);
		    vA0 = vec_xor(vA0, vB0);
		    vec_st(vA0, k, pA0);
		    __asm__
			__volatile__("vaddfp %0,%0,%1":"=v"(vA0):"v"(vM));
		    vec_st(vA0, k, (vector long *) pR0);
		}
	    } else {
		/* when  soboldim<20+32 */
		pA0 = (vector long *) lptrbuf;
		pB0 = (vector long *) lptr;
		pR0 = (vector float *) result;
		for (k = 0; k < (soboldim & ~3) << 2; k += 16) {
		    vA0 = vec_ld(k, pA0);
		    vB0 = vec_ld(k, pB0);
		    vA0 = vec_xor(vA0, vB0);
		    vec_st(vA0, k, pA0);
		    __asm__
			__volatile__("vaddfp %0,%0,%1":"=v"(vA0):"v"(vM));
		    vec_st(vA0, k, (vector long *) pR0);
		}
	    }
	}
	for (k = (soboldim & ~3); k < soboldim; k++) {
	    *(sobol_int *) (lptrbuf + k) ^= lptr[k];
	}
	for (k = (soboldim & ~3); k < soboldim; k++) {
	    result[k] = lptrbuf[k] - 1.;
	}
    }
    return;
#else
    /* PowerPC AltiVec code for double precision */
    {
	if (soboldim < 6) {
	    for (i = 0; i < soboldim; i++)
		y[i] ^= twist[k][i];
	    for (i = 0; i < soboldim; i++)
		result[i] = ((sobol_real *) y)[i] + (-1.);
	    return;
	} else {
	    register sobol_int *lptr asm("r7");
	    register sobol_real *lptrbuf asm("r8");
	    double *source, *destin;
	    double *sourcep1, *destinp1;
	    double *sourcep2, *destinp2;
	    double *sourcep3, *destinp3;
	    register int j;
	    const register double minus1 = -1.;
	    register int off0;
#define defb(i) vB##i asm("v" #i )
#define defa(i,j) vA##i asm("v" #j )
	    register vector long vB0, vA0;
	    register vector long *pA0, *pA1;
	    register vector long *pB0, *pB1;
#define vecldA(i,j)  __asm__ __volatile__("lvxl %0,%1,%2": :"v"(vA##i),"r"(off##j),"r"(pA##i))
#define vecldB(i,j)  __asm__ __volatile__("lvxl %0,%1,%2": :"v"(vB##i),"r"(off##j),"r"(pB##i))
#define xornow(i)    __asm__ __volatile__("vxor %0,%0,%1": :"v"(vA##i),"v"(vB##i))
#define vecstAA(i,j) __asm__ __volatile__("stvx %0,%1,%2": : "v"(vA##i),"r"(off##j),"r"(pA##i))

	    lptr = twist[k];
	    lptrbuf = (sobol_real *) y;
	    off0 = ((soboldim - 2) & ~3) << 3;
	    pA0 = (vector long *) ((int) lptrbuf + off0);
	    pA1 = pA0 + 1;
	    pB0 = (vector long *) ((int) lptr + off0);
	    pB1 = pB0 + 1;
	    off0 = -off0;
	    source = (double *) lptrbuf;
	    destin = (double *) result;
	    sourcep1 = source + 1;
	    sourcep2 = source + 2;
	    sourcep3 = source + 3;
	    destinp1 = destin + 1;
	    destinp2 = destin + 2;
	    destinp3 = destin + 3;
	    if (twnum + k == 0) {
		vB0 = vec_ld(off0, pB0);
		vec_st(vec_xor(vec_ld(off0, pA0), vB0), off0, pA0);
		pA0 += 2;
		j = 0;
		while (off0) {
		    vec_st(vec_xor(vec_ld(off0, pA1), vB0), off0, pA1);
		    destin[j] = source[j] + minus1;
		    destinp1[j] = sourcep1[j] + minus1;
		    vec_st(vec_xor(vec_ld(off0, pA0), vB0), off0, pA0);
		    destinp2[j] = sourcep2[j] + minus1;
		    off0 += 32;
		    destinp3[j] = sourcep3[j] + minus1;
		    j += 4;
		}
		destin[j] = source[j] + minus1;
		destinp1[j] = sourcep1[j] + minus1;
		pA0 -= 2;
		i = ((int) (lptrbuf + (soboldim & ~3)) - ((int) pA0));
		for (k = 16; k < i; k += 16) {
		    j += 2;
		    vA0 = vec_ld(k, pA0);
		    vA0 = vec_xor(vA0, vB0);
		    vec_st(vA0, k, pA0);
		    destin[j] = source[j] + minus1;
		    destinp1[j] = sourcep1[j] + minus1;
		}
		if (soboldim & 1) {
		    y[soboldim - 1] ^= lptr[0];
		    result[soboldim - 1] =
			*(double *) &y[soboldim - 1] + minus1;
		}
	    } else {
		vec_st(vec_xor(vec_ld(off0, pA0), vec_ld(off0, pB0)), off0,
		       pA0);
		pA0 += 2;
		pB0 += 2;
		j = 0;
		while (off0) {
		    vec_st(vec_xor(vec_ld(off0, pA1), vec_ld(off0, pB1)),
			   off0, pA1);
		    destin[j] = source[j] + minus1;
		    destinp1[j] = sourcep1[j] + minus1;
		    vec_st(vec_xor(vec_ld(off0, pA0), vec_ld(off0, pB0)),
			   off0, pA0);
		    destinp2[j] = sourcep2[j] + minus1;
		    off0 += 32;
		    destinp3[j] = sourcep3[j] + minus1;
		    j += 4;
		}
		destin[j] = source[j] + minus1;
		destinp1[j] = sourcep1[j] + minus1;
		pA0 -= 2;
		pB0 -= 2;
		i = ((int) (lptrbuf + (soboldim & ~3)) - ((int) pA0));
		for (k = 16; k < i; k += 16) {
		    j += 2;
		    vA0 = vec_ld(k, pA0);
		    vB0 = vec_ld(k, pB0);
		    vA0 = vec_xor(vA0, vB0);
		    vec_st(vA0, k, pA0);
		    destin[j] = source[j] + minus1;
		    destinp1[j] = sourcep1[j] + minus1;
		}
		if (soboldim & 1) {

		    y[soboldim - 1] ^= lptr[soboldim - 1];
		    result[soboldim - 1] =
			*(double *) &y[soboldim - 1] + minus1;
		}
	    }
	}
	return;
    }


#endif
#else
    /* probably some x86 architecture, the general code is also here */

    /* macros for some instructions */

#define loadpq(x,num) __asm__ __volatile__ ("movq %0,%%mm" #num ::"m"(x))
#define loadps(x,num) __asm__ __volatile__ ("movaps %0,%%xmm" #num ::"m"(x))
#define loadpd(x,num) __asm__ __volatile__ ("movapd %0,%%xmm" #num ::"m"(x))
#define xorps(x,num) __asm__ __volatile__  ("xorps  %0,%%xmm"  #num::"m"(x))
#define xorpd(x,num) __asm__ __volatile__  ("xorpd  %0,%%xmm"  #num::"m"(x))
#define xorq(num1,num2) __asm__ __volatile__  ("pxor  %mm" #num1 ",%mm" #num2)
#define xorxmm(num1,num2) __asm__ __volatile__  ("pxor  %xmm" #num1 ",%xmm" #num2)
#define xorpsr(num1,num2) __asm__ __volatile__  ("xorps  %xmm" #num1 ",%xmm" #num2)
#define addps(num1,num2) __asm__ __volatile__ ("addps  %xmm" #num1 ",%xmm" #num2);
#define addpd(num1,num2) __asm__ __volatile__ ("addpd  %xmm" #num1 ",%xmm" #num2);
#define subpsr(num1,num2) __asm__ __volatile__ ("subpd  %xmm" #num1 ",%xmm" #num2);
#define storeps(x,num) __asm__ __volatile__ ("movaps %%xmm" #num ",%0"::"m"(x))
#define storepd(x,num) __asm__ __volatile__ ("movapd %%xmm" #num ",%0"::"m"(x))
#define storeqq(x,num) __asm__ __volatile__ ("movq %%mm" #num ",%0"::"m"(x))
#define unp(instr,num1,num2) __asm__ __volatile__ (#instr " %xmm" #num1 ",%xmm" #num2)
#define unpq(instr,num1,num2) __asm__ __volatile__ (#instr " %mm" #num1 ",%mm" #num2)
#define xorpq(x,num) __asm__ __volatile__ ("pxor " " %0,%%mm" #num ::"m"(x))
#define addpqs(num1,num2) __asm__ __volatile__ ("pfadd  %mm" #num1 ",%mm" #num2);



#ifdef  SOBOL_P4
    /* x86 SSE2 instruction set */
#ifdef SOBOL_SINGLE
    /* Single Precision */
    {
	int i;
	sobol_int l;
	int avecnum;
	int n = soboldim >> 4;
	register sobol_int *sp1, *sp2;
	register sobol_real *sp3;
	static sobol_real minusone[4] __attribute__ ((aligned(16))) = {
	-1., -1., -1, -1};
	static sobol_int __attribute__ ((aligned(16))) constone[4] = {
	0x3f3f3f3f, 0x3f3f3f3f, 0x3f3f3f3f, 0x3f3f3f3f};
	avecnum = twnum + k;
	loadps(minusone[0], 4);
	loadps(constone[0], 5);
	sp1 = y;
	sp2 = twistpack[k];
	sp3 = result;
	if (avecnum < SOBOL_SCLIM) {
	    while (n) {
		loadps(sp1[0], 0);
		xorps(sp2[0], 0);
		storeps(sp1[0], 0);
		__asm__ __volatile__("movaps %xmm0,%xmm2");
		unp(punpcklbw, 5, 0);
		unp(punpckhbw, 5, 2);
		loadps(sp1[4], 6);
		__asm__ __volatile__("movaps %xmm6,%xmm1");
		unp(punpcklwd, 0, 6);
		unp(punpckhwd, 0, 1);
		addps(4, 6);
		addps(4, 1);
		storeps(sp3[0], 6);
		storeps(sp3[4], 1);
		loadps(sp1[8], 7);
		__asm__ __volatile__("movaps %xmm7,%xmm3");
		unp(punpcklwd, 2, 7);
		unp(punpckhwd, 2, 3);
		addps(4, 7);
		addps(4, 3);
		storeps(sp3[8], 7);
		storeps(sp3[12], 3);
		sp1 += 12;
		sp2 += 4;
		sp3 += 16;
		n--;
	    }
	} else {
	    while (n) {
		loadps(sp1[0], 0);
		xorps(sp2[0], 0);
		storeps(sp1[0], 0);
		__asm__ __volatile__("movaps %xmm0,%xmm2");
		unp(punpcklbw, 5, 0);
		unp(punpckhbw, 5, 2);
		loadps(sp1[4], 6);
		xorps(sp2[4], 6);
		storeps(sp1[4], 6);
		__asm__ __volatile__("movaps %xmm6,%xmm1");
		unp(punpcklwd, 0, 6);
		unp(punpckhwd, 0, 1);
		addps(4, 6);
		addps(4, 1);
		storeps(sp3[0], 6);
		storeps(sp3[4], 1);
		loadps(sp1[8], 7);
		xorps(sp2[8], 7);
		storeps(sp1[8], 7);
		__asm__ __volatile__("movaps %xmm7,%xmm3");
		unp(punpcklwd, 2, 7);
		unp(punpckhwd, 2, 3);
		addps(4, 7);
		addps(4, 3);
		storeps(sp3[8], 7);
		storeps(sp3[12], 3);
		sp1 += 12;
		sp2 += 12;
		sp3 += 16;
		n--;
	    }
	}

	{
	    int r = (soboldim >> 2) & 3;
	    if (r == 0)
		goto end;
	    loadps(sp1[0], 0);
	    xorps(sp2[0], 0);
	    storeps(sp1[0], 0);
	    addps(4, 0);
	    storeps(sp3[0], 0);
		sp1+=4;
		sp2+=4;
		sp3+=4;
	    if (r == 1)
		goto end;
	    loadps(sp1[0], 1);
	    xorps(sp2[0], 1);
	    storeps(sp1[0], 1);
	    addps(4, 1);
	    storeps(sp3[0], 1);
		sp1+=4;
                sp2+=4;
                sp3+=4;
	    if (r == 2)
		goto end;
	    loadps(sp1[0], 2);
	    xorps(sp2[0], 2);
	    storeps(sp1[0], 2);
	    addps(4, 2);
	    storeps(sp3[0], 2);
		sp1+=4;
                sp2+=4;
                sp3+=4;
	  end:
	}
	for (i = 0; i < soboldim&3; i++) {
	    sp1[i] ^= sp2[i];
	}
	for (i = 0; i < soboldim&3; i++) {
	    result[i+(soboldim&~3)] = *(sobol_real *) (sp1+i) + (-1);
	}
	/*tova e zle! 
	for (i = (soboldim & ~3); i < soboldim; i++) {
	    y[i] ^= twistpack[k][i];
	}
	for (i = (soboldim & ~3); i < soboldim; i++){
	    result[i] = *(sobol_real *) (y + i) + (-1);
	}
	*/
	return;

    }
#else
    /* SSE2 x86 architecture, double precision */
    {
	int i;
	sobol_int l;
	int avecnum;
	int n = soboldim >> 4;
	register long long int *sp1, *sp2;
	register double *sp3;
	static double minusone[2] __attribute__ ((aligned(16))) = {
	-1., -1.};
	static long long int __attribute__ ((aligned(16))) constone[2] = {
	0x3f3f3f3f3f3f3f3fLL, 0x3f3f3f3f3f3f3f3fLL};
	avecnum = twnum + k;
	loadpd(minusone[0], 4);
	loadpd(constone[0], 5);
	sp1 = y;
	sp2 = twistpack[k];
	sp3 = result;
	if (avecnum < SOBOL_SCLIM) {
	    while (n) {
		__asm__ __volatile__("prefetchnta %0"::"m"(sp1[32]));
		loadpd(sp1[0], 0);
		xorpd(sp2[0], 0);
		storepd(sp1[0], 0);
		__asm__ __volatile__("movapd %xmm0,%xmm2");
		unp(punpcklbw, 5, 0);
		unp(punpckhbw, 5, 2);
		loadpd(sp1[2], 6);
		__asm__ __volatile__("movapd %xmm6,%xmm1");
		unp(punpcklwd, 0, 1);
		unp(punpckhwd, 0, 6);
		loadpd(sp1[4], 3);
		__asm__ __volatile__("movapd %xmm3,%xmm7");
		unp(unpcklps, 1, 3);
		unp(unpckhps, 1, 7);
		addpd(4, 3);
		addpd(4, 7);
		storepd(sp3[0], 3);
		storepd(sp3[2], 7);
		loadpd(sp1[6], 0);
		__asm__ __volatile__("movapd %xmm0,%xmm1");
		unp(unpcklps, 6, 0);
		unp(unpckhps, 6, 1);
		addpd(4, 0);
		addpd(4, 1);
		storepd(sp3[4], 0);
		storepd(sp3[6], 1);
		loadpd(sp1[8], 3);
		__asm__ __volatile__("movapd %xmm3,%xmm7");
		unp(punpcklwd, 2, 3);
		unp(punpckhwd, 2, 7);
		loadpd(sp1[10], 0);
		__asm__ __volatile__("movapd %xmm0,%xmm1");
		unp(unpcklps, 3, 0);
		unp(unpckhps, 3, 1);
		addpd(4, 0);
		addpd(4, 1);
		storepd(sp3[8], 0);
		storepd(sp3[10], 1);
		loadpd(sp1[12], 2);
		__asm__ __volatile__("movapd %xmm2,%xmm6");
		unp(unpcklps, 7, 2);
		unp(unpckhps, 7, 6);
		addpd(4, 2);
		addpd(4, 6);
		storepd(sp3[12], 2);
		storepd(sp3[14], 6);
		sp1 += 14;
		sp2 += 2;
		sp3 += 16;
		n--;
	    }
	} else {
	    while (n) {
		loadpd(sp1[0], 0);
		xorpd(sp2[0], 0);
		storepd(sp1[0], 0);
		__asm__ __volatile__("movapd %xmm0,%xmm2");
		unp(punpcklbw, 5, 0);
		unp(punpckhbw, 5, 2);
		loadpd(sp1[2], 6);
		xorpd(sp2[2], 6);
		storepd(sp1[2], 6);
		__asm__ __volatile__("movapd %xmm6,%xmm1");
		unp(punpcklwd, 0, 1);
		unp(punpckhwd, 0, 6);
		loadpd(sp1[4], 3);
		xorpd(sp2[4], 3);
		storepd(sp1[4], 3);
		__asm__ __volatile__("movapd %xmm3,%xmm7");
		unp(unpcklps, 1, 3);
		unp(unpckhps, 1, 7);
		addpd(4, 3);
		addpd(4, 7);
		storepd(sp3[0], 3);
		storepd(sp3[2], 7);
		loadpd(sp1[6], 0);
		xorpd(sp2[6], 0);
		storepd(sp1[6], 0);
		__asm__ __volatile__("movapd %xmm0,%xmm1");
		unp(unpcklps, 6, 0);
		unp(unpckhps, 6, 1);
		addpd(4, 0);
		addpd(4, 1);
		storepd(sp3[4], 0);
		storepd(sp3[6], 1);
		loadpd(sp1[8], 3);
		xorpd(sp2[8], 3);
		storepd(sp1[8], 3);
		__asm__ __volatile__("movapd %xmm3,%xmm7");
		unp(punpcklwd, 2, 3);
		unp(punpckhwd, 2, 7);
		loadpd(sp1[10], 0);
		xorpd(sp2[10], 0);
		storepd(sp1[10], 0);
		__asm__ __volatile__("movapd %xmm0,%xmm1");
		unp(unpcklps, 3, 0);
		unp(unpckhps, 3, 1);
		addpd(4, 0);
		addpd(4, 1);
		storepd(sp3[8], 0);
		storepd(sp3[10], 1);
		loadpd(sp1[12], 2);
		xorpd(sp2[12], 2);
		storepd(sp1[12], 2);
		__asm__ __volatile__("movapd %xmm2,%xmm6");
		unp(unpcklps, 7, 2);
		unp(unpckhps, 7, 6);
		addpd(4, 2);
		addpd(4, 6);
		storepd(sp3[12], 2);
		storepd(sp3[14], 6);
		sp1 += 14;
		sp2 += 14;
		sp3 += 16;
		n--;
	    }
	}
	/* Finish the unrolled loop */
	for (i = (soboldim&(~15)); i < (soboldim&(~1)); i += 2) {
	    loadpd(sp1[0], 0);
	    xorpd(sp2[0], 0);
	    storepd(sp1[0], 0);
	    addpd(4, 0);
	    storepd(sp3[0], 0);
	    sp1 += 2;
	    sp2 += 2;
	    sp3 += 2;
	}
	if (soboldim & 1) {
	    y[soboldim - 1] ^= twistpack[k][soboldim - 1];
	    result[(soboldim - 1)] =
		*(sobol_real *) (y + (soboldim - 1)) + (-1.);
	}
	return;
    }

#endif
#else

#ifdef SOBOL_P3
#ifdef SOBOL_SINGLE
    /* SSE1 x86, single precision */
    {
	int i;
	sobol_int l;
	int avecnum;
	int n = soboldim >> 4;
	register sobol_int *sp1, *sp2;
	register sobol_real *sp3;
	static sobol_real minusone[4] __attribute__ ((aligned(16))) = {
	-1., -1., -1., -1.};
	static sobol_int plusonehalf[4] __attribute__ ((aligned(16))) = {
	0x00400000, 0x00400000, 0x00400000, 0x00400000};
	avecnum = twnum + k;
	loadps(minusone[0], 4);
	if (avecnum == 0) {
	    loadps(plusonehalf[0], 5);
	    __asm__ __volatile__("movaps %xmm5,%xmm7");
	}
	__asm__ __volatile__("movaps %xmm4,%xmm6");
	sp1 = y;
	sp2 = twist[k];
	sp3 = result;
	if (avecnum == 0) {
	    while (n) {
		/* no improvement observed by this - __asm__ __volatile__ ("prefetchnta %0"::"m"(sp1[32])); */
		loadps(sp1[0], 0);
		loadps(sp1[4], 1);
		loadps(sp1[8], 2);
		loadps(sp1[12], 3);
		xorpsr(5, 0);
		xorpsr(7, 1);
		xorpsr(5, 2);
		xorpsr(7, 3);
		storeps(sp1[0], 0);
		storeps(sp1[4], 1);
		storeps(sp1[8], 2);
		storeps(sp1[12], 3);
		addps(4, 0);
		addps(6, 1);
		addps(4, 2);
		addps(6, 3);
		storeps(sp3[0], 0);
		storeps(sp3[4], 1);
		storeps(sp3[8], 2);
		storeps(sp3[12], 3);
		n--;
		sp1 += 16;
		sp3 += 16;
	    }
	    sp2 += (soboldim & ~15);
	} else {
	    while (n) {
		/* no improvement observed by this - __asm__ __volatile__ ("prefetchnta %0"::"m"(sp1[32])); */
		loadps(sp1[0], 0);
		loadps(sp1[4], 1);
		loadps(sp1[8], 2);
		loadps(sp1[12], 3);
		xorps(sp2[0], 0);
		xorps(sp2[4], 1);
		xorps(sp2[8], 2);
		xorps(sp2[12], 3);
		storeps(sp1[0], 0);
		storeps(sp1[4], 1);
		storeps(sp1[8], 2);
		storeps(sp1[12], 3);
		addps(4, 0);
		addps(6, 1);
		addps(4, 2);
		addps(6, 3);
		storeps(sp3[0], 0);
		storeps(sp3[4], 1);
		storeps(sp3[8], 2);
		storeps(sp3[12], 3);
		n--;
		sp1 += 16;
		sp2 += 16;
		sp3 += 16;
	    }
	}
	{
	    int r = (soboldim >> 2) & 3;
	    if (r == 0)
		goto end;
	    loadps(sp1[0], 0);
	    xorps(sp2[0], 0);
	    storeps(sp1[0], 0);
	    addps(4, 0);
	    storeps(sp3[0], 0);
	    if (r == 1)
		goto end;
	    loadps(sp1[4], 1);
	    xorps(sp2[4], 1);
	    storeps(sp1[4], 1);
	    addps(6, 1);
	    storeps(sp3[4], 1);
	    if (r == 2)
		goto end;
	    loadps(sp1[8], 2);
	    xorps(sp2[8], 2);
	    storeps(sp1[8], 2);
	    addps(4, 2);
	    storeps(sp3[8], 2);
	  end:
	}
	for (i = (soboldim & ~3); i < soboldim; i++) {
	    y[i] ^= twist[k][i];
	}
	for (i = (soboldim & ~3); i < soboldim; i++)
	    result[i] = *(sobol_real *) (y + i) + (-1);
	return;
    }
#else
    /*SSE1 x86 architecture,  double precision generation */
    {
	int i;
	sobol_int l;
	int avecnum;
	int n = soboldim >> 3;
	register int *sp1, *sp2;
	static sobol_int plusonehalf[2] __attribute__ ((aligned(16))) = {
	0x0008000000000000LL, 0x0008000000000000LL};
	avecnum = twnum + k;
	if (avecnum == 0) {
	    loadps(plusonehalf[0], 5);
	}
	__asm__ __volatile__("movaps %xmm4,%xmm6");
	__asm__ __volatile__("movaps %xmm5,%xmm7");
	sp1 = (int *) y;
	sp2 = (int *) twist[k];
	if (avecnum == 0) {
	    sp2 += (soboldim & ~7) << 1;
	    while (n) {
		/* no improvement observed by this -  __asm__ __volatile__ ("prefetchnta %0"::"m"(sp1[32])); */
		loadps(sp1[0], 0);
		loadps(sp1[4], 1);
		loadps(sp1[8], 2);
		loadps(sp1[12], 3);
		xorpsr(5, 0);
		xorpsr(7, 1);
		xorpsr(5, 2);
		xorpsr(7, 3);
		storeps(sp1[0], 0);
		storeps(sp1[4], 1);
		storeps(sp1[8], 2);
		storeps(sp1[12], 3);
		n--;
		sp1 += 16;
	    }
	} else {
	    while (n) {
		/* __asm__ __volatile__ ("prefetchnta %0"::"m"(sp1[32]));  - no improvement observed by this */
		loadps(sp1[0], 0);
		loadps(sp1[4], 1);
		loadps(sp1[8], 2);
		loadps(sp1[12], 3);
		xorps(sp2[0], 0);
		xorps(sp2[4], 1);
		xorps(sp2[8], 2);
		xorps(sp2[12], 3);
		storeps(sp1[0], 0);
		storeps(sp1[4], 1);
		storeps(sp1[8], 2);
		storeps(sp1[12], 3);
		n--;
		sp1 += 16;
		sp2 += 16;
	    }
	}
	for (i = 0; i < (soboldim & ~7); i += 8) {
	    result[i] = *(sobol_real *) (y + i) + (-1.);
	    result[i + 1] = *(sobol_real *) (y + i + 1) + (-1.);
	    result[i + 2] = *(sobol_real *) (y + i + 2) + (-1.);
	    result[i + 3] = *(sobol_real *) (y + i + 3) + (-1.);
	    result[i + 4] = *(sobol_real *) (y + i + 4) + (-1.);
	    result[i + 5] = *(sobol_real *) (y + i + 5) + (-1.);
	    result[i + 6] = *(sobol_real *) (y + i + 6) + (-1.);
	    result[i + 7] = *(sobol_real *) (y + i + 7) + (-1.);
	}
	/* Finish the unrolled loop */
	for (i = 0; i < (soboldim & 6); i += 2) {
	    loadps(sp1[0], 0);
	    xorps(sp2[0], 0);
	    storeps(sp1[0], 0);
	    sp1 += 4;
	    sp2 += 4;
	}
	if (soboldim & 1) {
	    y[soboldim - 1] ^= twist[k][soboldim - 1];
	}
	for (i = (soboldim & ~7); i < soboldim; i++)
	    result[i] = *(sobol_real *) (y + i) + (-1);
	return;
    }


#endif
#endif
#endif
#ifdef SOBOL_MMX
#ifdef SOBOL_SINGLE
    /* MMX x86 instruction set , single precision */
    {
	int i;
	sobol_int l;
	int avecnum;
	float minusone = -1.;
	register char *sp1 asm("esi") = (char *) y;
	register char *sp2 asm("edi");
	static int firstpass = 1;
	int n = soboldim >> 3;
	static sobol_int plusonehalf[2] __attribute__ ((aligned(8))) = {
	0x00400000, 0x00400000};
	sp2 = (char *) (twist[k]);
	avecnum = twnum + k;
	l = (n << 5);
	sp1 += l;
	l = -l;
	if (avecnum == 0) {
	    loadpq(plusonehalf[0], 0);
	    __asm__ __volatile__("movq %mm0,%mm1");
	    __asm__ __volatile__("movq %mm0,%mm2");
	    __asm__ __volatile__("movq %mm0,%mm3");
	    while (l) {
		loadpq(sp1[l + 0], 4);
		loadpq(sp1[l + 8], 5);
		loadpq(sp1[l + 16], 6);
		loadpq(sp1[l + 24], 7);
		xorq(0, 4);
		xorq(1, 5);
		xorq(2, 6);
		xorq(3, 7);
		storeqq(sp1[l + 0], 4);
		storeqq(sp1[l + 8], 5);
		storeqq(sp1[l + 16], 6);
		storeqq(sp1[l + 24], 7);
		l += 32;
	    }
	} else {
	    if (avecnum < SOBOL_SCLIM) {
		__asm__ __volatile__("pxor %mm0,%mm0");
		while (l) {
		    loadpq(sp2[0], 2);
		    __asm__ __volatile__("movq %mm2,%mm3");
		    unpq(punpcklbw, 0, 2);
		    unpq(punpckhbw, 0, 3);
		    __asm__ __volatile__("movq %mm0,%mm4");
		    __asm__ __volatile__("movq %mm0,%mm5");
		    unpq(punpcklwd, 2, 4);
		    unpq(punpckhwd, 2, 5);
		    xorpq(sp1[l + 0], 4);
		    xorpq(sp1[l + 8], 5);
		    __asm__ __volatile__("movq %mm0,%mm6");
		    __asm__ __volatile__("movq %mm0,%mm7");
		    unpq(punpcklwd, 3, 6);
		    unpq(punpckhwd, 3, 7);
		    xorpq(sp1[l + 16], 6);
		    xorpq(sp1[l + 24], 7);
		    storeqq(sp1[l + 0], 4);
		    storeqq(sp1[l + 8], 5);
		    storeqq(sp1[l + 16], 6);
		    storeqq(sp1[l + 24], 7);
		    sp2 += 8;
		    l += 32;
		}
	    } else {
		sp2 -= l;
		while (l) {
		    loadpq(sp1[l + 0], 4);
		    loadpq(sp1[l + 8], 5);
		    loadpq(sp1[l + 16], 6);
		    loadpq(sp1[l + 24], 7);
		    xorpq(sp2[l + 0], 4);
		    xorpq(sp2[l + 8], 5);
		    xorpq(sp2[l + 16], 6);
		    xorpq(sp2[l + 24], 7);
		    storeqq(sp1[l + 0], 4);
		    storeqq(sp1[l + 8], 5);
		    storeqq(sp1[l + 16], 6);
		    storeqq(sp1[l + 24], 7);
		    l += 32;
		}
		/* Tyka dovarshen li e cikala - losho! */
	    }
	}

	__asm__ __volatile__("emms");
	for (i = (soboldim & ~7); i < soboldim; i++) {
	    y[i] ^= twist[k][i];
	}
	{
	    float *source, *destin;
	    const float min1 = -1;
	    source = (sobol_real *) y;
	    destin = result;
	    for (i = 0; i < soboldim; i += 4) {
		destin[0] = source[0] + min1;
		destin[1] = source[1] + min1;
		destin[2] = source[2] + min1;
		destin[3] = source[3] + min1;
		source += 4;
		destin += 4;
	    }
	    for (i = (soboldim & ~3); i < soboldim; i++) {
		destin[0] = source[0] + min1;
		destin++;
		source++;
	    }
	}
	return;
    }
#else
    //double, mmx or athlon

    {
	int i;
	sobol_int l;
	int avecnum;
	char *sp1 = (char *) y;
	char *sp2;
	int n = soboldim >> 3;
	static sobol_int plusonehalf[2] __attribute__ ((aligned(8))) = {
	0x0008000000000000LL};
	sp2 = (char *) (twist[k]);
	avecnum = twnum + k;
	l = (n << 6);
	sp1 += l;
	l = -l;
	if (avecnum == 0) {
	    loadpq(plusonehalf[0], 0);
	    __asm__ __volatile__("movq %mm0,%mm1");
	    __asm__ __volatile__("movq %mm0,%mm2");
	    __asm__ __volatile__("movq %mm0,%mm3");
	    while (l) {
		loadpq(sp1[l + 0], 4);
		loadpq(sp1[l + 8], 5);
		loadpq(sp1[l + 16], 6);
		loadpq(sp1[l + 24], 7);
		xorq(0, 4);
		xorq(1, 5);
		xorq(2, 6);
		xorq(3, 7);
		storeqq(sp1[l + 0], 4);
		storeqq(sp1[l + 8], 5);
		storeqq(sp1[l + 16], 6);
		storeqq(sp1[l + 24], 7);
		l += 32;
	    }
	} else {
	    if (avecnum < SOBOL_SCLIM) {
		__asm__ __volatile__("pxor %mm0,%mm0");
		while (l) {
		    loadpq(sp2[0], 2);
		    __asm__ __volatile__("movq %mm2,%mm3");
		    unpq(punpcklbw, 0, 2);
		    unpq(punpckhbw, 0, 3);
		    __asm__ __volatile__("movq %mm0,%mm4");
		    __asm__ __volatile__("movq %mm0,%mm5");
		    unpq(punpcklwd, 2, 4);
		    unpq(punpckhwd, 2, 5);
		    __asm__ __volatile__("movq %mm0,%mm6");
		    __asm__ __volatile__("movq %mm0,%mm7");
		    unpq(punpckldq, 4, 6);
		    unpq(punpckhdq, 4, 7);
		    xorpq(sp1[l + 0], 6);
		    xorpq(sp1[l + 8], 7);
		    storeqq(sp1[l + 0], 6);
		    storeqq(sp1[l + 8], 7);
		    __asm__ __volatile__("movq %mm0,%mm2");
		    __asm__ __volatile__("movq %mm0,%mm4");
		    unpq(punpckldq, 5, 2);
		    unpq(punpckhdq, 5, 4);
		    xorpq(sp1[l + 16], 2);
		    xorpq(sp1[l + 24], 4);
		    storeqq(sp1[l + 16], 2);
		    storeqq(sp1[l + 24], 4);
		    __asm__ __volatile__("movq %mm0,%mm4");
		    __asm__ __volatile__("movq %mm0,%mm5");
		    unpq(punpcklwd, 3, 4);
		    unpq(punpckhwd, 3, 5);
		    __asm__ __volatile__("movq %mm0,%mm6");
		    __asm__ __volatile__("movq %mm0,%mm7");
		    unpq(punpckldq, 4, 6);
		    unpq(punpckhdq, 4, 7);
		    xorpq(sp1[l + 32], 6);
		    xorpq(sp1[l + 40], 7);
		    storeqq(sp1[l + 32], 6);
		    storeqq(sp1[l + 40], 7);
		    __asm__ __volatile__("movq %mm0,%mm2");
		    __asm__ __volatile__("movq %mm0,%mm4");
		    unpq(punpckldq, 5, 2);
		    unpq(punpckhdq, 5, 4);
		    xorpq(sp1[l + 48], 2);
		    xorpq(sp1[l + 56], 4);
		    storeqq(sp1[l + 48], 2);
		    storeqq(sp1[l + 56], 4);
		    sp2 += 8;
		    l += 64;
		}
	    } else {
		sp2 -= l;
		while (l) {
		    loadpq(sp1[l + 0], 4);
		    loadpq(sp1[l + 8], 5);
		    loadpq(sp1[l + 16], 6);
		    loadpq(sp1[l + 24], 7);
		    xorpq(sp2[l + 0], 4);
		    xorpq(sp2[l + 8], 5);
		    xorpq(sp2[l + 16], 6);
		    xorpq(sp2[l + 24], 7);
		    storeqq(sp1[l + 0], 4);
		    storeqq(sp1[l + 8], 5);
		    storeqq(sp1[l + 16], 6);
		    storeqq(sp1[l + 24], 7);
		    l += 32;
		}
	    }
	    //dovarshi cikala
	}
	__asm__ __volatile__("emms");
	for (i = (soboldim & ~7); i < soboldim; i++) {
	    *(y + i) ^= twist[k][i];
	}
	//opravi sumiraneto
	for (i = 0; i < (soboldim & ~3); i += 4) {
	    result[i] = ((sobol_real *) y)[i] + (-1.);
	    result[i + 1] = ((sobol_real *) y)[i + 1] + (-1.);
	    result[i + 2] = ((sobol_real *) y)[i + 2] + (-1.);
	    result[i + 3] = ((sobol_real *) y)[i + 3] + (-1.);
	}
	for (i = (soboldim & ~3); i < soboldim; i++) {
	    result[i] = ((sobol_real *) y)[i] + (-1.);
	}
	return;

    }
#endif
#endif
#ifdef SOBOL_ATHLON
#ifdef SOBOL_SINGLE
    //samo single athlon version e tyka, inache e gore

    {
	int i;
	sobol_int l;
	int avecnum;
	int n = soboldim >> 3;
	register sobol_int *sp1, *sp2;
	register sobol_real *sp3;
	static sobol_real minusone[2] __attribute__ ((aligned(8))) = {
	-1., -1.,};
	static sobol_int __attribute__ ((aligned(16))) constone[2] = {
	0x3f3f3f3f, 0x3f3f3f3f};
	avecnum = twnum + k;
	loadpq(minusone[0], 4);
	loadpq(constone[0], 5);
	sp1 = y;
	sp2 = twistpack[k];
	sp3 = result;
	if (avecnum < SOBOL_SCLIM) {
	    while (n) {
		loadpq(sp1[0], 0);
		xorpq(sp2[0], 0);
		storeqq(sp1[0], 0);
		__asm__ __volatile__("movq %mm0,%mm2");
		unpq(punpcklbw, 5, 0);
		unpq(punpckhbw, 5, 2);
		loadpq(sp1[2], 6);
		__asm__ __volatile__("movq %mm6,%mm1");
		unpq(punpcklwd, 0, 6);
		unpq(punpckhwd, 0, 1);
		addpqs(4, 6);
		addpqs(4, 1);
		storeqq(sp3[0], 6);
		storeqq(sp3[2], 1);
		loadpq(sp1[4], 7);
		__asm__ __volatile__("movq %mm7,%mm3");
		unpq(punpcklwd, 2, 7);
		unpq(punpckhwd, 2, 3);
		addpqs(4, 7);
		addpqs(4, 3);
		storeqq(sp3[4], 7);
		storeqq(sp3[6], 3);
		sp1 += 6;
		sp2 += 2;
		sp3 += 8;
		n--;
	    }
	} else {
	    while (n) {
		loadpq(sp1[0], 0);
		xorpq(sp2[0], 0);
		storeqq(sp1[0], 0);
		__asm__ __volatile__("movq %mm0,%mm2");
		unpq(punpcklbw, 5, 0);
		unpq(punpckhbw, 5, 2);
		loadpq(sp1[2], 6);
		xorpq(sp2[2], 6);
		storeqq(sp1[2], 6);
		__asm__ __volatile__("movq %mm6,%mm1");
		unpq(punpcklwd, 0, 6);
		unpq(punpckhwd, 0, 1);
		addpqs(4, 6);
		addpqs(4, 1);
		storeqq(sp3[0], 6);
		storeqq(sp3[2], 1);
		loadpq(sp1[4], 7);
		xorpq(sp2[4], 7);
		storeqq(sp1[4], 7);
		__asm__ __volatile__("movq %mm7,%mm3");
		unpq(punpcklwd, 2, 7);
		unpq(punpckhwd, 2, 3);
		addpqs(4, 7);
		addpqs(4, 3);
		storeqq(sp3[4], 7);
		storeqq(sp3[6], 3);
		sp1 += 6;
		sp2 += 6;
		sp3 += 8;
		n--;
	    }

	}
	__asm__ __volatile__("emms");
	for (i = 0; i < (soboldim & 7); i++) {
	    sp1[i] ^= sp2[i];
	}
	for (i = 0; i < (soboldim & 7); i++) {
	    sp3[i] = *(sobol_real *) (sp1 + i) + (-1.);
	}
	return;
    }
    //krai athlon single
#endif
#endif
#endif
/*general code */
#ifdef SOBOL_NOOPT
    {
	const sobol_real minus1 = -1.;
	int *yptr, *twistptr;
	sobol_real *yrealptr;
#ifdef SOBOL_SINGLE

	for (i = 0; i < soboldim; i++)
	    y[i] ^= twist[k][i];
	for (i = 0; i < (soboldim & ~1); i += 2) {
	    result[i] = *(sobol_real *) & y[i] + minus1;
	    result[i + 1] = ((sobol_real *) & y[i])[1] + minus1;
	}
	if (soboldim & 1) {
	    result[i] = *(sobol_real *) & y[i] + minus1;
	}
#else
/* 
   for (i=0;i<((soboldim&~1)<<1);i+=2){
	*(int*)&y[i]^=((int*)&twist[k][i])[0];
	((int*)&y[i])[1]^=((int*)&twist[k][i])[1];  
	((int*)&y[i])[2]^=((int*)&twist[k][i])[2]; 
	((int*)&y[i])[3]^=((int*)&twist[k][i])[3]; 
   } 
   if (soboldim&1){  
	*(int*)&y[i]^=((int*)&twist[k][i])[0];
        ((int*)&y[i])[1]^=((int*)&twist[k][i])[1];
   }
   for (i=0;i<(soboldim&~1);i+=2)   {
                result[i]= *(sobol_real*)&y[i]+minus1;
                result[i+1]=((sobol_real*)&y[i])[1]+minus1;
   }
   if (soboldim&1){
         result[i]= *(sobol_real*)&y[i]+minus1;
   }
*/
	yptr = (int *) y;
	twistptr = (int *) twist[k];
	for (i = 0; i < ((soboldim & ~1) << 2); i += 4) {
	    yptr[i] ^= twistptr[i];
	    yptr[i + 1] ^= twistptr[i + 1];
	    yptr[i + 2] ^= twistptr[i + 2];
	    yptr[i + 3] ^= twistptr[i + 3];
	}
	if (soboldim & 1) {
	    yptr[i] ^= twistptr[i];
	    yptr[i + 1] ^= twistptr[i + 1];
	}
	yrealptr = (sobol_real *) y;
	for (i = 0; i < (soboldim & ~1); i += 2) {
	    result[i] = yrealptr[i] + minus1;
	    result[i + 1] = yrealptr[i + 1] + minus1;
	}
	if (soboldim & 1) {
	    result[i] = yrealptr[i] + minus1;
	}
#endif
    }
#endif
}
double sobol_test_getpoint(sobol_int n, int dim, sobol_int scramble)
{
    double s;
    double res;
    int i, j;
    union {
	double resa;
	long long longa;
    } x;
    LLONG p1, p;
    p = 1;
    p1 = 0;
    p1 = scramble;
#ifdef SOBOL_SINGLE
    p1 = p1 << (32 - 3);
#endif
#define TESTMP 52
    for (i = 0; p <= n; i++, p += p) {
	if (n & p) {
	    p1 ^= (LLONG) avect[i][dim] << (TESTMP - i - 1);
	}
    }
    res = p1 / (double) ((LLONG) 1 << (TESTMP));
    return res;
}

/* Global definitions globals:*/
sobol_real sobolranpoints[SOBOL_MAXDIM] __attribute__ ((aligned(16)));
double (*sobolranfunc) () = NULL;
static sobol_int scrambles[SOBOL_MAXDIM];
sobol_real *sobolptr;
sobol_real *sobolrbound;

static double randd()
{
    return (double) rand() / (double) RAND_MAX;
}

int sobolprepare(double fromtraj, int maxlentraj)
{

    int i;
    if (!dataread) {
	sobolreaddata();
    }
    for (i = 0; i < maxlentraj; i++){
	scrambles[i] = (sobol_int) (randd() * pow(2, SOBOL_MAXPOW - 1));
    }
    sobolpreprocess(maxlentraj, 0, fromtraj, scrambles);
    sobolptr = sobolranpoints;
    sobolrbound = sobolptr + maxlentraj;
}

void sobolnexttraj()
{
    sobolptr = sobolranpoints;
    sobolnextpoint(sobolranpoints);
}

void *sobolalignmem(int numreals)
{
    void *p;
    p = malloc(numreals * sizeof(double) + 16);
    if ((int) p & ~0xf) {
	p = (void *) (((int) p + 0x10) & ~0xf);
    }
    return p;
}
